////////////////////////////////////////////////////////////////////////////
// (C) copyright 2011 HC Sharp Software Inc. All Rights Reserved. 
// No duplication or use of this source code is allowed without permission.
// If you use this software you agree to do so at your own risk and you agree
// not to hold the author liable for any damages or injury of any kind. 
// The author assumes NO liability. 
//
// WARNING: This code contains bugs which could cause injury or death
// if you actually used it for any purpose other than your own education. 
/////////////////////////////////////////////////////////////////////////////

#ifndef _TESLAUMC_H_
#define _TESLAUMC_H_

// PINOUTS PIC18F2221
/*
1	Vpp			hi voltage programmer.			
2	RA0/AN0		Analog input for EV voltage
3	RA1/AN1		Analog input for tempurature sensor
4	RA2			LED Grn
5	RA3			LED Yel
6	RA4			
7	RA5			
8	Vss			
9	RA7/OSC1	Xtal
10	RA6/OSC2	Xtal		
11	RC0			LED 16A
12	RC1			LED 24A
13	RC2/CCP1	PWM Out
14	RC3			LED 32A
15	RC4			LED 40A
16	RC5			LED 48A
17	RC6			LED 60A
18	RC7			LED 70A
19	Vss			Gnd
20	Vdd			+5v
21	RB0
22	RB1
23	RB2
24	RB3
25	RB4			Push Button
26	RB5
27	RB6/PGC		Programmer/Debugger
28	RB7/PBD		Programmer/Debugger
*/



// name output pins for LEDs etc
#define LED_GRN_PORT	porta
#define LED_YEL_PORT	porta
#define LED_GRN_PIN		1
#define LED_YEL_PIN		2	

#define LED_XA_PORT		portc
#define LED_16A			0
#define LED_24A			1
#define LED_32A			3
#define LED_40A			4
#define LED_48A			5
#define LED_60A			6
#define LED_70A			7

#define BUTTON_PORT		portb
#define BUTTON_PIN		RB5

#define PWM_PORT		portc
#define PWM_PIN			2

// analog pin for EV return voltage
#define EV_VOLTS_PORT	porta
#define EV_VOLTS_PIN	RA0


// used to combine 2 8bit registers into one 16 bit value
typedef	struct _twoBytes {				
			unsigned char	cLoByte;
			unsigned char	cHiByte;
	} twoBytes;
	
typedef union _twoBytesUnion {
			unsigned int uWord;
			twoBytes	 bytes;
	} twoBytesUnion;



uint  getAD(void);					// samples AD pin 64 times and returns average in 16 bits




#endif //_TESLAUMC_H_
